var system = require("../../../system");
var settings = require("../../../../config/settings");
const AppServiceBase = require("../../app.base");
const querystring = require('querystring');
const md5 = require("MD5");
const NodeRSA = require('node-rsa');
class utilsTlBankSve extends AppServiceBase {
  constructor() {
    super();
    this.logCtl = system.getObject("service.common.oplogSve");
    this.apppaliparamDao = system.getObject("db.dbapp.apppaliparamDao");

  }
  //-------------------------------------------钉钉h5支付-----------------开始

  /**
   * 唤起钉钉h5支付信息---只供简单应用
   * @param {*} pobj 
   * @param {*} actionBody {total_fee:总额，单位为分，order_num:订单号，body_desc:标题描述}
   */
  async getH5AliDingPayInfo(pobj, actionBody) {
    var payParam = await this.apppaliparamDao.getItemByUAppId(pobj.appInfo.uapp_id);
    if (!payParam) {
      return { status: -310, msg: "应用没有对应的支付凭证" }
    }
    var parameters = {
      service: "mobile.securitypay.pay",
      partner: payParam.partner,
      _input_charset: "utf-8",
      notify_url: payParam.notify_url,
      out_trade_no: actionBody.order_num,
      subject: actionBody.body_desc,
      payment_type: "1",
      seller_id: payParam.seller_id,
      total_fee: actionBody.total_fee,
      sign_type: "RSA"
    };

    var signStr = await this.getCreateAliSignStr(payParam, parameters);
    parameters.sign = signStr;
    return system.getResultSuccess(parameters);
  }

  async getCreateAliSignStr(payParam, parameters) {
    let userPrivateKey = payParam.privatekey;
    const key = new NodeRSA();
    key.setOptions({ b: 1024, signingScheme: "sha1" });
    key.importKey(userPrivateKey, 'pkcs8-private');//导入密钥并设定格式
    const publicDer = key.exportKey('pkcs8-public');
    let text = Object.keys(parameters).sort().map(key => {
      return `${encodeURIComponent(key)}=${encodeURIComponent(parameters[key])}`
    }).join('&');
    let buffer = Buffer.from(text);
    let signature = key.sign(buffer).toString('base64');
    return signature;
  }


  //-------------------------------------------钉钉h5支付-----------------结束

}
module.exports = utilsTlBankSve;
