var system = require("../../../system");
var settings = require("../../../../config/settings");
const AppServiceBase = require("../../app.base");
const logCtl = system.getObject("service.common.oplogSve");
//商标查询操作
class UtilsUserSve extends AppServiceBase {
  constructor() {
    super();
    this.apppaliparamDao = system.getObject("db.dbapp.apppaliparamDao");
  }
  async getH5AliDingUserByCode(pobj) {
    var item = await this.apppaliparamDao.getItemByUAppId(Number(pobj.appInfo.uapp_id || 0));
    if (!item) {
      return system.getResult(null, "应用对应的配置数据为空!");
    }
    var param = {
      appkey: item.appkey,
      appsecret: item.appsecret
    };
    var accessTokenResult = await this.execGetUrl(param, "https://oapi.dingtalk.com/gettoken");
    this.logCtl.info({
      appid: pobj.appInfo ? pobj.appInfo.uapp_id : "",
      appkey: pobj.appInfo ? pobj.appInfo.uapp_key : "",
      op: "https://oapi.dingtalk.com/gettoken",
      content: "参数：" + JSON.stringify(param) + "返回结果：" + JSON.stringify(accessTokenResult),
      optitle: "获取钉钉access_token信息返回",
    });
    if (accessTokenResult.status != 0) {
      return accessTokenResult;
    }
    if (accessTokenResult.errcode != 0) {
      return system.getResult(null, accessTokenResult.errmsg);
    }
    param = {
      access_token: accessTokenResult.access_token,
      code: pobj.actionBody.code
    };
    var userResult = await this.execGetUrl(param, "https://oapi.dingtalk.com/user/getuserinfo");
    this.logCtl.info({
      appid: pobj.appInfo ? pobj.appInfo.uapp_id : "",
      appkey: pobj.appInfo ? pobj.appInfo.uapp_key : "",
      op: "https://oapi.dingtalk.com/user/getuserinfo",
      content: "参数：" + JSON.stringify(param) + "返回结果：" + JSON.stringify(userResult),
      optitle: "获取钉钉用户信息返回",
    });
    if (userResult.status != 0) {
      return userResult;
    }
    if (userResult.errcode != 0) {
      return system.getResult(null, userResult.errmsg + "-userResult");
    }
    return system.getResultSuccess({
      channelUserId: userResult.userid,
      isAdmin: userResult.is_sys && userResult.is_sys == true ? 1 : 0,
      isSuper: userResult.sys_level && userResult.sys_level == 1 ? 1 : 0
    });
  }
  
}
module.exports = UtilsUserSve;
